<?php

/*
Plugin Name: WPaudio
Plugin URI: http://wpaudio.com
Description: Play mp3s and podcasts in your posts by converting audio tags and/or links into a totally customizable CSS-skinnable Javascript-controlled audio player.  (Skinning coming soon.)
Version: 1.3.1
Author: Todd Iceton
Author URI: http://ticeton.com

Copyright 2009 Todd Iceton (email : t@ticeton.com)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

*/

## TO DO
## - Soundmanager
## - Make players an array, stop playing if another is started
## - Integrate with attachment add (js and post - look at highslide)
## - Don't call scripts if no audio
## - OO for wpaFilter
## - Add option for built-in jQuery

## Pre-2.6 compatibility (from WP codex)
if ( ! defined( 'WP_CONTENT_URL' ) )
	define( 'WP_CONTENT_URL', get_option( 'siteurl' ) . '/wp-content' );
if ( ! defined( 'WP_CONTENT_DIR' ) )
	define( 'WP_CONTENT_DIR', ABSPATH . 'wp-content' );
if ( ! defined( 'WP_PLUGIN_URL' ) )
	define( 'WP_PLUGIN_URL', WP_CONTENT_URL. '/plugins' );
if ( ! defined( 'WP_PLUGIN_DIR' ) )
	define( 'WP_PLUGIN_DIR', WP_CONTENT_DIR . '/plugins' );
if ( ! defined( 'WPA_URL' ) )
	define( 'WPA_URL', WP_PLUGIN_URL . '/wpaudio-mp3-player' );

## WP handlers
# Built-in jQuery (inactive -- currently using Google CDN)
add_action('init', 'wpaLibraries');
# Add header action to include CSS and call Google CDN JQuery/SWFObject
add_action('wp_head', 'wpaHead');
# Add shortcode for WPaudio player
add_shortcode('wpaudio', 'wpaShortcode');
# Add filter for shortcode in excerpt and widgets
add_filter('the_excerpt', 'do_shortcode');
add_filter('widget_text', 'do_shortcode');
# Add filter for non-shortcode substitutes (including excerpts and widgets)
if (get_option('wpa_tag_audio')) {
	add_filter('the_content', 'wpaFilter');
	add_filter('the_excerpt', 'wpaFilter');
	add_filter('widget_text', 'wpaFilter');
}

## Built-in libraries
function wpaLibraries(){
	wp_enqueue_script('jquery');
}

## WPaudio style, jQuery, SWFObject
function wpaHead(){
	# Player CSS
	$head = <<<WPA
<style type="text/css">
.wpa_container {position: relative; margin: 0; padding: 0; font-family: Arial, Sans-serif; line-height: 1; text-align: left;}
.wpa_play {position: absolute; top: 0; left: 0; width: 16px; height: 15px; margin-top: 2px; background: #777 url(WPA_URL/wpa_button.gif) 0px 0px; cursor: pointer; overflow: hidden;}
.wpa_meta, .wpa_bar, .wpa_sub {margin-left: 20px;}
.wpa_meta {font-size: 18px; font-weight: bold; letter-spacing: -1px; line-height: 18px;}
.wpa_meta a {text-decoration: none; color: #24f;}
.wpa_meta a:hover {color: #02f;}
.wpa_placeholder {font-size: 11px; font-weight: normal; letter-spacing: 0;}
.wpa_bar {display: none; position: relative; height: 5px; margin-top: 2px; background: #eee; overflow: hidden;}
.wpa_bar_load {position: absolute; top: 0; left: 0; width: 0; height: 5px; z-index: 10; background: #ccc;}
.wpa_bar_position {position: absolute; top: 0; left: 0; width: 0; height: 5px; z-index: 11; background: #46f;}
.wpa_bar_click {position: absolute; top: 0; left: 0; width: 100%; height: 5px; z-index: 12; background: transparent; cursor: pointer;}
.wpa_sub {display: none; margin-top: 2px; font-size: 11px; color: #999;}
.wpa_time {}
</style>
WPA;
	# Call Google CDN JQuery
	/* $head .= <<<WPA
<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.3/jquery.min.js"></script>
WPA; */
	# Common JS
	$head .= <<<WPA
<script type="text/javascript" src="WPA_URL/sm2/soundmanager2-nodebug-jsmin.js"></script>
<script type="text/javascript">
var wpa = Array();
var wpa_params = Array();
var wpa_pref_bar = true;
var wpa_pref_sub = true;

soundManager.debugMode = false;
soundManager.url = 'WPA_URL/sm2/';
soundManager.nullURL = 'WPA_URL/sm2/null.mp3';
soundManager.useHighPerformance = true;
soundManager.useFastPolling = false;
soundManager.waitForWindowLoad = true;

// When player is ready, add wpa clip objects to wpa array. Show error if error.
soundManager.onready(function(oStatus){
	if (oStatus.success && isset('wpa_params')) {
		for (i in wpa_params) {
			wpa.push(new wpaClip(wpa_params[i]));
			jQuery('#wpa' + i + '_placeholder').hide();
		}
	}
});
soundManager.onerror(function(){
	jQuery('.wpa_placeholder').innerHTML('<br>WPaudio Player could not load.  Do you have <a href="http://get.adobe.com/flashplayer/">Adobe Flash</a> installed?');
});

// Wpa clip object
function wpaClip(params) {
	this.id = params.id;
	this.url = params.url;
	this.text = params.text;
	this.dl = params.dl;
	this.duration = 0;
	this.player = soundManager.createSound({
		id: 'wpa' + this.id,
		url: this.url,
		// In the following functions, 'this' refers to the player
		whileplaying: function() {
			jQuery('#' + this.sID + '_bar_position').width(this.position/wpa[this.sID.substr(3)].duration*100 + '%');
			jQuery('#' + this.sID + '_position').text(wpaTimeFormat(this.position));
		},
		whileloading: function() {
			wpa[this.sID.substr(3)].duration = (this.bytesLoaded == this.bytesTotal) ? this.duration : this.durationEstimate;
			jQuery('#' + this.sID + '_bar_load').width(this.bytesLoaded/this.bytesTotal*100 + '%');
			jQuery('#' + this.sID + '_duration').text(wpaTimeFormat(wpa[this.sID.substr(3)].duration));
		},
		onid3: function() {
			if (wpa[this.sID.substr(3)].text)
				return;
			var text;
			if (this.id3.artist) text = this.id3.artist;
			if (this.id3.artist && this.id3.songname) text += ' - ';
			if (this.id3.songname) text += this.id3.songname;
			wpa[this.sID.substr(3)].textChange(text);
			this.unload();
		},
		onplay: function() {wpa[this.sID.substr(3)].buttonCheck();},
		onpause: function() {wpa[this.sID.substr(3)].buttonCheck();},
		onresume: function() {wpa[this.sID.substr(3)].buttonCheck();},
		onstop: function() {wpa[this.sID.substr(3)].buttonCheck();}
	});
	// If text is not presupplied, load to get id3
	if (!this.text) this.player.load();
	// Set the width of the bar to the width of the meta info
	this.barWidth = function() {
		jQuery('#wpa' + this.id + '_bar').width(jQuery('#wpa' + this.id + '_meta').width())
	};
	this.barWidth();
	// Change meta text and set bar width
	this.textChange = function(text) {
		this.text = text;
		jQuery('#wpa' + this.id + '_meta').text(text);
		this.barWidth();
	};
	// Play or pause
	this.play = function() {
		// Pause any other playing players if this player is stopped, about to play, and handle button image
		if (!this.player.playState || this.player.paused) soundManager.pauseAll();
		soundManager.togglePause(this.player.sID);
		var id = this.id;
		if (wpa_pref_bar) {
			jQuery('#wpa' + id + '_bar').slideDown('slow', function(){
				if (wpa_pref_sub) {
					jQuery('#wpa' + id + '_sub').fadeIn('slow');
				}
			});
		}
	};
	// Jog track
	this.jog = function(percent) {
		if (!this.player.playState || this.player.paused) this.play();
		this.player.setPosition(this.duration * percent);
	}
	// Check button for css sprite
	this.buttonCheck = function() {
		if (!this.player.playState || this.player.paused) 
			jQuery('#wpa' + this.id + '_play').css('backgroundPosition', '0px 0px');
		else
			jQuery('#wpa' + this.id + '_play').css('backgroundPosition', '0px 15px');
	}
}

// Add click handlers for play button and jog bar
jQuery(document).ready(function() {
	jQuery('.wpa_play').click(function(){
		wpa[jQuery(this).attr('id').split('_',1)[0].substr(3)].play();
	});
	jQuery('.wpa_bar_click').click(function(e){ //DONE
		// Allow clicks on status bar to jog track
		var id = jQuery(this).attr('id').split('_',1)[0].substr(3);
		if (e.pageX) {
			var percent = (e.pageX - jQuery(this).offset()['left']) / jQuery(this).width();
			wpa[id].jog(percent);
		}
	});
});

function isset(varname){ // For checking user-set variables
	return(typeof(window[varname])!='undefined');
}
function wpaTimeFormat(ms) {
	var min = Math.floor(ms / 1000 / 60);
	var sec = Math.floor(ms / 1000 % 60);
	var time_string = min + ':';
	if (sec<10) time_string += '0'; // Add leading 0 to seconds if necessary
	time_string += sec;
	return(time_string);
}
</script>
WPA;
	echo str_replace('WPA_URL', WPA_URL, $head);
}

# Declare global wpa_id to be incremented for multiple players
$wpa_id = 0;

# Used only for wpaudio shortcode tags
function wpaShortcode($atts){
	# Convert shortcodes to WPaudio player depending on settings
	extract(shortcode_atts(Array(
		'url' => false,
		'text' => false,
		'dl' => true
	), $atts));
	# If no url, return with nothing
	if (!url)
		return;
	# ID number for players, will be incremented for each player instance
	global $wpa_id;
	# Get player HTML and JS
	$player = wpaPlayerHtml($wpa_id, $url, $text, $dl);
	$player .= wpaPlayerJs($wpa_id, $url, $text, $dl);
	$wpa_id++;
	return $player;
}

# Used for audio tags
function wpaFilter($content){
	# Convert audio tags and links to WPaudio player depending on settings
	$tag_regex = '/\[audio:(.*?)\]/';
	$link_regex = '/<a href=["\'](http:\/\/.*?\.mp3)["\']>(.*?)<\/a>/';
	$tag_match = preg_match_all($tag_regex, $content, $tag_matches);
	$link_match = preg_match_all($link_regex, $content, $link_matches);
	# If no matches, return content unchanged
	if (!($tag_match || $link_match))
		return $content;
	# ID number for players, will be incremented for each instance
	global $wpa_id;
	# String for unique player JS
	$player_js = '';
	# Replace audio tags with player
	if ($tag_match){
		foreach ($tag_matches[1] as $key => $value){
			# This is one tag, first get parameters and URLs
			$params = explode('|', $value);
			$clips = Array('urls' => Array(), 'titles' => Array(), 'artists' => Array());
			$clips['urls'] = explode(',', $params[0]);
			# Process extra parameters if they exist
			for ($i=1; $i<count($params); $i++) {
				# Get the parameter name and value
				$param = explode('=', $params[$i]);
				if ($param[0] == 'titles' || $param[0] == 'artists')
					$clips[$param[0]] = explode(',', $param[1]);
			}
			# Get player(s)
			$player_html = '';
			foreach ($clips['urls'] as $ukey => $uvalue) {
				$text = '';
				$text .= (isset($clips['artists'][$ukey])) ? $clips['artists'][$ukey] : '';
				$text .= (isset($clips['artists'][$ukey]) && isset($clips['titles'][$ukey])) ? ' - ' : '';
				$text .= (isset($clips['titles'][$ukey])) ? $clips['titles'][$ukey] : '';
				if (!$text) $text = false;
				$player_html .= wpaPlayerHtml($wpa_id, $uvalue, $text);
				$player_js .= wpaPlayerJs($wpa_id, $uvalue, $text);
				$wpa_id++;
			}
			$content = str_replace($tag_matches[0][$key], $player_html, $content);
		}
	}
	### FIX PATHS
	# Create document.ready with player_js
	$content .= $player_js;
	return $content;
}

# Common to all players
function wpaPlayerHtml($id, $url, $text = false, $dl = true){
	# Return the html for a player given id
	$html = <<<WPA
<!-- wpa0 html begin -->
<div class="wpa_container">
	<div id="wpa0_play" class="wpa_play"></div>
	<div><!-- req'd for correct IE6 display -->
		<div class="wpa_meta">
WPA;
	if ($dl) $html .= '<a href="MP3URL" target="_blank"><span id="wpa0_meta">MP3BASE</span></a>';
	else $html .= '<span id="wpa0_meta">MP3BASE</span>';
	$html .= <<<WPA
<span id="wpa0_placeholder" class="wpa_placeholder"><noscript><br><a href="http://wpaudio.com/javascript" target="_blank">Enable Javascript</a> to play audio content on this site.</noscript></span>
		</div>
		<div id="wpa0_bar" class="wpa_bar">
			<div id="wpa0_bar_load" class="wpa_bar_load"></div>
			<div id="wpa0_bar_position" class="wpa_bar_position"></div>
			<div id="wpa0_bar_click" class="wpa_bar_click"></div>
		</div>
		<div id="wpa0_sub" class="wpa_sub">
			<div id="wpa0_time" class="wpa_time"><span id="wpa0_position">0:00</span> / <span id="wpa0_duration">0:00</span></div>
		</div>
	</div>
</div>
<!-- wpa0 html end -->
WPA;
	$html = str_replace('wpa0', "wpa$id", $html);
	if ($dl)
		$html = ($dl === true) ? str_replace('MP3URL', $url, $html) : str_replace('MP3URL', $dl, $html);
	$html = ($text) ? str_replace('MP3BASE', $text, $html) : str_replace('MP3BASE', basename($url), $html);
	return $html;
}
function wpaPlayerJs($id, $url, $text = false, $dl = true){
	# Return the js for a given id and url
 	$js = <<<WPA
<!-- wpaMP3ID js begin -->
<script type="text/javascript">
wpa_params.push({'id': MP3ID, 'url': 'MP3URL', 'text': false, 'dl': false})
</script>
<!-- wpaMP3ID js end -->
WPA;
	$js = str_replace('MP3ID', $id, $js);
	$js = str_replace('MP3URL', $url, $js);
	if ($text) $js = str_replace("'text': false", "'text': '" . str_replace("'", "\'", $text) . "'", $js);
	if ($dl) $js = str_replace("'dl': false", "'dl': '$dl'", $js);
	return $js;
}

## WP options
add_option('wpa_tag_audio', false);
# WP admin menu
add_action('admin_menu', 'wpa_menu');
function wpa_menu() {
	add_options_page('WPaudio Options', 'WPaudio', 10, __FILE__, 'wpa_menu_page');
}
function wpa_menu_page() {
	if (isset($_POST['wpa_tag_audio'])) {
		if ($_POST['wpa_tag_audio'])
			update_option('wpa_tag_audio', true);
		else
			update_option('wpa_tag_audio', false);
	}
	echo <<<WPA
<!-- wpa menu begin -->
<div class="wrap">
<h2>WPaudio Options</h2>
<form method="POST" action="">
WPA;
	wp_nonce_field('update-options');	
	echo <<<WPA
	<p>WPaudio tags take the format <span style="font-family: Courier, Serif">[wpaudio url="http://domain.com/song.mp3"]</span>, but you can also convert older Audio Player tags.</p>
	<p>
		<b>Convert <span style="font-family: Courier, Serif">[audio:http://domain.com/song.mp3]</span> tags?</b><br>
WPA;
	# WPA audio tag
	echo '<input name="wpa_tag_audio" id="wpa_tag_audio_yes" value="1" type="radio"';
	if (get_option('wpa_tag_audio'))
		echo ' checked="yes"';
	echo '> <label for="wpa_tag_audio_yes">Yes, convert audio tags too.</label><br>';
	echo '<input name="wpa_tag_audio" id="wpa_tag_audio_no" value="0" type="radio"';
	if (!get_option('wpa_tag_audio'))
		echo ' checked="yes"';
	echo '> <label for="wpa_tag_audio_no">No, convert only WPaudio tags. (default)</label>';
	echo <<<WPA
	</p>
	<p><input type="submit" value="Save"></p>
</form>
</div>
<!-- wpa menu end -->
WPA;
}

?>
